// -*-C++-*-
// the above makes emacs understand that this is  C++ header

/// RAndom Graphs
// #include <malloc.h>
#include <iostream.h>
#include <fstream.h>
//#include <stdio.h>
//#include <string.h>
#include <stdlib.h>
//#include <ctype.h>
#include <math.h>


//-------- Type declarations ---------
#define   INDEX			long
#define   WEIGHT			double
#define   BOOL                   int      // YES ==  1 , NO == 0
#define   PROB                   double 
#define   COOR                   double
#define   CAP                   double
#define   DELAY                   double


typedef  long  NODEID;
typedef  long  HOPS;
typedef long int SEED_type;
// ------- Constants ------------------
#define   NL  "\n"
#define   BL  " "
#define   NO_EDGE		-1
#define   NONE                   -1
#define   startNodeId		0
#define   YES			1
#define   NO			0
#define   OK                     10
#define	  CHANGELINE		50
#define   JOIN_CODE               1
#define   REMOVE_CODE             2
#define   USER_REQ_str         "U"

//------------   CLASSES ---------------
// class MyEdge;
class Session;
class Probab;
class MyRequest;
class myIO;
class Creation;
// -------- Debugging -----------------
#define debug(str)
//#define debug(str)    (Out << str )
//------- file declarations -------------
#define		Out 		cout 
#define          Inf             cin 


// ------ Global variable -----------------------
// X_MAX and Y_MAX correspond to the grid for Euclidean Random graphs
#ifdef MAIN
#define extern
#endif

extern char 	Outfile[30];

#ifdef MAIN
#undef extern
#endif

//---------------- CLASSES --------------------


class myIO {
  //  InitFile.open("InitFile.dat", ios::in);
  //private:
  
public:
  double readNL() ;
  //  myIO() {InitFile.open("InitFile.dat", ios::in)} ;

};

class MyRequest {
private:
  Session    *sess;
  NODEID  toNode;
  DELAY   delay;
  CAP     band;
  HOPS    hops;
public:

  setReq(Session *sess, NODEID to, DELAY del, CAP band, HOPS h);
  setDelay(DELAY del);
  setCap(CAP b);
  print();
};

class Session {

public:
  Session(INDEX sess, INDEX nodes);
  BOOL isInSession(INDEX node) {return Parti[node];};
  BOOL newJoin();
  BOOL newRemove();
  INDEX getSource() {return source;};
  void print();
  void Session::printJoin(INDEX node, CAP band, DELAY del, HOPS hops);
  void Session::printRemove(INDEX node);
  void setParti(INDEX node, BOOL stat) { Parti[node] = stat; };
  void setQoS(INDEX levels, CAP minB, CAP maxB, DELAY minD, DELAY maxD, \
	      HOPS minH, HOPS maxH);

private:
	NODEID  source;
  INDEX nNodes;
  BOOL *Parti;  // Array of which node participates in session
  INDEX id;

  INDEX  avgSize;
  INDEX  nQoSLevels;
  CAP    maxBand;
  CAP    minBand;
  DELAY  minDelay;
  DELAY  maxDelay;
  HOPS   minHops;
  HOPS   maxHops;
  // Probabilities *Prob;

};

class Creation {


public:
  Creation();
  void run(int argc, char **argv);
  BOOL readInit();
  oneMoreTrans(){ currTrans++; };
  Session * getSess(INDEX s) { return allSess[s]; };
  BOOL Creation::doJoin();
  BOOL Creation::doRemove();
  INDEX Creation::selectSess();
  void Creation::printSessions();
  void setOrderedJoinLeave(BOOL val) { orderedJoinLeave = val;};
  BOOL getOrderedJoinLeave() { return orderedJoinLeave;};

private:
  BOOL   orderedJoinLeave; // 1 means on join one leave, 0 = random
  NODEID nNodes;
  INDEX  nSessions;
  INDEX  maxTrans;   // maximum number of transactions
  INDEX  currTrans;  // current number of transactions
  Session **allSess;  // array with pointr to all sessions


  INDEX  avgSize;
  INDEX  nQoSLevels;
  CAP    maxBand;
  CAP    minBand;
  DELAY  minDelay;
  DELAY  maxDelay;
  HOPS   minHops;
  HOPS   maxHops;
  //   Probabilities *Prob;
};

class Probab{
  // All methods are static so they can be used
  // by anyone with just: Probab::method()
public:
  
  static  void initRandomProb(SEED_type seed) {
    srand48(seed);
  }
static  PROB randomProb(SEED_type seed) {
  // PROB [0.0, 1.0)
  ///srand48(seed);  /// initialization
  return (PROB) drand48();

}

static  int uni_inter_Prob(double min, double max, SEED_type seed){
  // RETURN an int randomly distributed
  //         in the [min, max] interval
  double value;

  value = randomProb(seed) * (max - min) + min;
  // --- round value ----
  // add a small number .3 so that
  // both min and max can be achieved
  value = (int) (value + .5);
  return (int) value;

}

static BOOL biasedCoin(PROB bias) {
    if (randomProb(0) > bias)  
      return YES;
    else return NO;
  }

static BOOL coinFlip(){  return biasedCoin(.5); }

};
